//ScoreCode Example Client
//Note to self: add in GNU readline support for console interaction
#include <iostream>
#include <string>
#include <unistd.h>
#include "scorecode.h"

void note_on1(int note){
	std::cout << "noteon 0 " << note << " 100" << std::endl;
}

void note_off1(int note){
	std::cout << "noteoff 0 " << note << std::endl;
}

void pan_right1(){
	//std::cout << "1: Pan Right" << std::endl;
}

void pan_left1(){
	//std::cout << "1: Pan Left" << std::endl;
}

void pan_center1(){
	//std::cout << "1: Pan Center" << std::endl;
}


void note_on2(int note){
	std::cout << "noteon 1 " << note << " 100" << std::endl;
}

void note_off2(int note){
	std::cout << "noteoff 1 " << note << std::endl;
}

void pan_right2(){
	//std::cout << "2: Pan Right" << std::endl;
}

void pan_left2(){
	//std::cout << "2: Pan Left" << std::endl;
}

void pan_center2(){
	//std::cout << "2: Pan Center" << std::endl;
}

int main(int c, char *argv[]){
	//make interpreter
	ScoreCode s(120,2);
	
	//register callbacks
	s.registerNoteOnCallback(0, &note_on1);
	s.registerNoteOffCallback(0, &note_off1);
	s.registerPanRightCallback(0, &pan_right1);
	s.registerPanLeftCallback(0, &pan_left1);
	s.registerPanCenterCallback(0, &pan_center1);
	
	s.registerNoteOnCallback(1, &note_on2);
	s.registerNoteOffCallback(1, &note_off2);
	s.registerPanRightCallback(1, &pan_right2);
	s.registerPanLeftCallback(1, &pan_left2);
	s.registerPanCenterCallback(1, &pan_center2);
	
	std::string pattern1 = "![o+++o]....+o..!+++o.";
	std::string pattern2 = "!..[---------o]..--o..!o.";
	
	s.pushPattern(0, pattern1);
	s.pushPattern(1, pattern2);
	
	//give fluidsynth time to start up
	sleep(10);
	
	s.run();
	
	s.pushPattern(0, pattern1);
	s.pushPattern(1, pattern2);

	sleep(8);
	
	return 0;
}
